/*
Made by Afghan Goat
*/
class VariableDisplayer{
	constructor(tab_name="📊 Variable Watch Panel"){
		this.panel = document.createElement("div");
		this.panel.style.position = "fixed";
		this.panel.style.bottom = "0";
		this.panel.style.right = "0";
		this.panel.style.background = "#111";
		this.panel.style.color = "#0f0";
		this.panel.style.padding = "1em";
		this.panel.style.fontFamily = "monospace";
		this.panel.style.fontSize = "14px";
		this.panel.style.zIndex = "9999";
		this.panel.innerHTML = "<strong>"+tab_name+"</strong><br>";
		this.showed=false;
		this.show();
		document.body.appendChild(this.panel);

		this.varId = 0;
		this.variables = new Map();
	}
	show(){
		if(this.showed===false){
			this.showed=true;
			this.panel.style.display="block";
		}
	}
	hide(){
		if(this.showed===true){
			this.showed=false;
			this.panel.style.display="none";
		}
	}
	setPosition(x=0,y=0){
		this.panel.style.bottom = y+"px";
		this.panel.style.right = x+"px";
	}
	add_variable(variableRef, label = `var_${++this.varId}`) {
		const line = document.createElement("div");
		this.panel.appendChild(line);

		const intervalId=setInterval(() => {
			const value = typeof variableRef === 'function' ? variableRef() : variableRef;
			line.textContent = `🟢 ${label}: ${value}`;
		}, 500);
		
		this.variables.set(label, { intervalId, element: line });
	}
	
	remove_variable(label) {
		const tracked = this.variables.get(label);
		if(tracked) {
			clearInterval(tracked.intervalId);
			tracked.element.remove();
			this.variables.delete(label);
		}
	}
};
module.exports = VariableDisplayer;
//Usage:
//const VariableDisplayer = require('./VariableDisplayer');
//const displayer= new VariableDisplayer("Your displayer name");
//displayer.add_variable(() => variable, "Variable display name");
//displayer.remove_variable("Variable display name");